KY Document.Info
T standardDocument
KY Document.SeqChapters
N Preface
Intro. to Scripts and the Script Mgmt. System
Script Systems
Script Manager Overview and Concepts
Script Manager Techniques
Script Manager Constants and Data Structures
Script Manager Routines
Appendix A: Testing for Compatibility
Appendix B: International Resources
Appendix C: Word Break Tables
Appendix D: Keyboards
Appendix E: Enhancements to 'PACK' 6
Appendix F: Change History
Appendix G: General Reference
Appendix H: Assembly-Language Info.
Appendix I: Working with Print Drivers
C card 3
card 7
card 33
card 64
card 108
card 151
card 197
card 286
card 287
card 288
card 294
card 304
card 308
card 311
card 313
card 318
KY Document.AlphaChapters
N Appendix A: Testing for Compatibility
Appendix B: International Resources
Appendix C: Word Break Tables
Appendix D: Keyboards
Appendix E: Enhancements to 'PACK' 6
Appendix F: Change History
Appendix G: General Reference
Appendix H: Assembly-Language Info.
Appendix I: Working with Print Drivers
Intro. to Scripts and the Script Mgmt. System
Preface
Script Manager Constants and Data Structures
Script Manager Overview and Concepts
Script Manager Routines
Script Manager Techniques
Script Systems
C card 286
card 287
card 288
card 294
card 304
card 308
card 311
card 313
card 318
card 7
card 3
card 151
card 64
card 197
card 108
card 33
KY Preface.Sections
N About this manual
About the Script Manager and System Software Release 6.0.4
Gestalt selectors for the Script Management System
Aids to understanding
C card 3
card 4
card 5
card 6
KY Intro. to Scripts and the Script Mgmt. System.Sections
N About this chapter
Features of scripts
Character representation
Character and line direction
Contextual forms
Uppercase and lowercase characters
Components of script systems
Character encoding
Character input
Composition rules
Sorting
Primary or secondary order
Expansion
Contraction
Ignorable characters
Exceptional words
Formats
Date and time
Calendars
Numbers
Utility routines
Objectives of a script management system
Completeness
Extensibility
Configurability
Compatibility
C card 7
card 8
card 9
card 10
card 11
card 12
card 13
card 14
card 15
card 16
card 17
card 18
card 19
card 20
card 21
card 22
card 23
card 24
card 25
card 26
card 27
card 28
card 29
card 30
card 31
card 32
KY Intro. to Scripts and the Script Mgmt. System.Figures
N Figure 1-1  Three text directions
Figure 1-1-1  English analog
Figure 1-2  Contextual forms
Figure 1-3  Ligatures
C line 3 of card 10
line 7 of card 10
line 3 of card 11
line 7 of card 11
KY Script Systems.Sections
N About this chapter
Types of script systems
What script systems do
Examples of script systems
The Kanji Script System
Input methods
Character conversion
Sorting
The Arabic Script System
Character input and line direction
Sorting in Arabic
General features of script systems
Methods for changing scripts
Changing keyboards in a single script
Configuring calendars and input methods
Specifying geographic location
Simple script systems
Middle Eastern script systems and issues
Character direction
Highlighting
The caret
East Asian script systems
Base text
Conversion
Phrases
Options
In-line conversion
Reverse conversion
Editing characters in fonts
Dictionary editing
Input method command reference
C card 33
card 34
card 35
card 36
card 37
card 38
card 39
card 40
card 41
card 42
card 43
card 44
card 45
card 46
card 47
card 48
card 49
card 50
card 51
card 52
card 53
card 54
card 55
card 56
card 57
card 58
card 59
card 60
card 61
card 62
card 63
KY Script Systems.Figures
N Figure 2-1  Types of script systems
Figure 2-1-1  Number of bytes per character
Figure 2-2  Contextual forms in Arabic
Figure 2-3  Arabic ligatures
Figure 2-4  Arabic Script System Configuration CDEV
Figure 2-5  Arabic Calendar CDEV
Figure 2-6  Script keyboard symbol
Figure 2-7  Arabic Key Caps
Figure 2-8  Kanji Keyboard CDEV
Figure 2-9  Kanji Script System Configuration CDEV
Figure 2-10  Map CDEV
Figure 2-11  Example of highlighting
Figure 2-12  Example of caret position between two runs of text
Figure 2-13  Methods for inputting Chinese
Figure 2-14  Base text in the Input window
Figure 2-15  Conversion
Figure 2-16  Phrases
Figure 2-17  Options
Figure 2-18  Reverse conversion
Figure 2-19  Editing characters
Figure 2-20  Dictionary editing
C line 9 of card 34
line 5 of card 40
line 3 of card 41
line 7 of card 41
line 5 of card 43
line 9 of card 43
line 3 of card 45
line 11 of card 45
line 3 of card 46
line 5 of card 47
line 15 of card 48
line 5 of card 52
line 5 of card 53
line 5 of card 54
line 3 of card 55
line 3 of card 56
line 5 of card 57
line 3 of card 58
line 6 of card 60
line 3 of card 61
line 7 of card 62
KY Script Systems.Tables
N Table 2-1  Keycap combinations for input
C line 3 of card 63
KY Script Manager Overview and Concepts.Sections
N About this chapter
About the Script Manager
Supporting script systems
Coordinating script systems
Calling a script system
Related system components
Distinguishing scripts
Implementation
Architecture
Script Manager dispatching
Keyboards
Sorting in the International Utilities
Date and time formats
Fonts
Text rendering 
Text manipulation capabilities
Localization
Concepts
Special character codes
Modifier keys
Extended Roman character set
Enhancements
Local and global variables
Format runs and higher-level text organization
Extracting Roman text from text in a non-Roman font
Text manipulation
Font script and keyboard script
Font forcing
Writing direction
Text editing 
Tokens
Date conversion
Number conversion
User configuration and control 
Overview of the Script Manager routines
Checking and modifying global and local variables
Checking and setting system variables
Setting the current keyboard
Obtaining script information
Obtaining character information
Manipulating text
Lexically interpreting different scripts
Date and time utilities
Number utilities
C card 64
card 65
card 66
card 67
card 68
card 69
card 70
card 71
card 72
card 73
card 74
card 75
card 76
card 77
card 78
card 79
card 80
card 81
card 82
card 83
card 84
card 85
card 86
card 87
card 88
card 89
card 90
card 91
card 92
card 93
card 94
card 95
card 96
card 97
card 98
card 99
card 100
card 101
card 102
card 103
card 104
card 105
card 106
card 107
KY Script Manager Overview and Concepts.Figures
N Figure 3-1  Procedure call to the Script Manager
Figure 3-2  The Script Manager international components
Figure 3-3  The Script Manager architecture
Figure 3-4  Character reordering in Devanagari script (for the word hindi)
Figure 3-5  Extended Roman character set
Figure 3-6  Text organization
Figure 3-7  Extracting blocks of Roman text
Figure 3-8  Two current scripts
C line 3 of card 68
line 7 of card 69
line 7 of card 72
line 5 of card 78
line 3 of card 84
line 3 of card 87
line 3 of card 88
line 3 of card 90
KY Script Manager Overview and Concepts.Tables
N Table 3-1  Low ASCII characters to avoid
C line 3 of card 82
KY Script Manager Techniques.Sections
N About this chapter
Calling the Script Manager from assembly language
Testing for the Script Manager
Obtaining character information
Parsing
Key-down event handling
Partitioning text
Drawing font names
Application and system fonts
Determining the script in use
Determining script codes with a font family ID
Displaying script icon IDs
Setting the keyboard script
Keeping the font script and keyboard script synchronized
Setting the keyboard script from the font script
Setting the font script from the keyboard script 
Drawing and measuring text
Handling justified text
Using search and replace
Working with TextEdit
Using TE Undo
Buffering text
Using TE DestRect and ViewRect
Using embedded characters
Working with character offsets
Using intelligent cut and paste
Using word processing
Changing fonts in multiformat text
Text ordering
Highlighting
Caret positioning with multiformat text
Mapping text resources for bilingual applications
Using the International Utilities package
Accessing the International Resources
Working with date formats and calendar conversion
Setting up the LongDateTime value
Working with numeric strings
Working with number formats
Separators	
Digits
Control
Marks
Literals
C card 108
card 109
card 110
card 111
card 112
card 113
card 114
card 115
card 116
card 117
card 118
card 119
card 120
card 121
card 122
card 123
card 124
card 125
card 126
card 127
card 128
card 129
card 130
card 131
card 132
card 133
card 134
card 135
card 136
card 137
card 138
card 139
card 140
card 141
card 142
card 143
card 144
card 145
card 146
card 147
card 148
card 149
card 150
KY Script Manager Techniques.Figures
N Figure 4-1  Determining script codes with font family IDs
Figure 4-2  Extra spacing to be supplied for DrawJust
Figure 4-3  Calendar conversion
C line 15 of card 118
line 27 of card 125
line 89 of card 142
KY Script Manager Techniques.Tables
N Table 4-1  Fields of the LongDateRec data structure
C line 55 of card 142
KY Script Manager Constants and Data Structures.Sections
N About this chapter
Constants
Current version number
Character set extensions 
CharType character types and classes
CharType field masks
CharType character types
Additional CharType character types
CharType classes 
Addt'l CharType classes
Additional CharType information
CharByte byte types
Direction constants (for Char2Pixel)
Bit definitions for general and local flags
Bits in script (local) flags word
Bits in Script Manager general flags
Script system numbers
Miscellaneous constants
Language codes
GetScript and SetScript verbs
GetEnvirons and SetEnvirons verbs
GetScript and SetScript return values
Transliterate target types
TokenType values 
NumberParts indices 
String2Date status values 
ToggleDate result codes
Date equates
LongDateRec field masks
The dateStdMask
Script Manager data structures
GetFormatOrder data structures
ParseTable data structure
FindWord and HiLiteText data structures
The 'itlc' data structure 
The 'itlb' data structure
IntlTokenize data structures
The TokenRec record
The TokenBlock record
Time and Date data structures
Location data structures
TogglePB data structure
Number format data structures
The 'itl4' record
FindScriptRun data structure 
StyledLineBreak data structure 
C card 151
card 152
card 153
card 154
card 155
card 156
card 157
card 158
card 159
card 160
card 161
card 162
card 163
card 164
card 165
card 166
card 167
card 168
card 169
card 170
card 171
card 172
card 173
card 174
card 175
card 176
card 177
card 178
card 179
card 180
card 181
card 182
card 183
card 184
card 185
card 186
card 187
card 188
card 189
card 190
card 191
card 192
card 193
card 194
card 195
card 196
KY Script Manager Constants and Data Structures.Figures
N Figure 5-1  Fields in the CharType return value
C line 9 of card 155
KY Script Manager Routines.Sections
N About this chapter
Underlying assumptions
Char2Pixel
CharByte
CharType
DrawJust
FindScriptRun 
FindWord 
Font2Script
FontScript
Format2Str 
FormatX2Str
FormatStr2X 
GetAppFont
GetDefFontSize
GetEnvirons
Global variables
Script Manager version number
Global modification count
Script enabled count
Bidirectional script flag
Font forcing flags
Print action vector
System and keyboard scripts
System Folder volume reference number
Keyboard swapping resource handle
Script override flag
Intercharacter and word space allocation
GetFormatOrder 
GetMBarHeight
GetScript 
Local variables
Script interface version number
Local modification count
Script enabled flag
Right-to-left flag
Justification flag
Word redraw flag 
Preferred system font
Preferred application font
Script 'itl0' ID
Script 'itl1' ID 
Script 'itl2' ID
smScriptFlags
Script 'itl4' ID
smScriptLang
smScriptNumDate
Reserved variables
Script 'KCHR' 
Script 'SICN' ID 
Script printer action routine
Trap entry pointer
Script file creator
Script file name
Script name
GetSysFont
GetSysJust
HiLiteText
InitDateCache 
IntlScript
IntlTokenize 
IULDateString 
IULTimeString
KeyScript 
LongDate2Secs 
LongSecs2Date
LwrString 
LwrText
MeasureJust
ParseTable
Pixel2Char
PortionText 
ReadLocation 
SetEnvirons
SetScript 
SetSysJust 
Str2Format 
String2Date 
String2Time 
StyledLineBreak
ToggleDate 
Transliterate 
Arabic and Hebrew versions
Japanese and Chinese versions
UprText
UprTextL 
ValidDate 
VisibleLength
WriteLocation
C card 197
card 198
card 199
card 200
card 201
card 202
card 203
card 204
card 205
card 206
card 207
card 208
card 209
card 210
card 211
card 212
card 213
card 214
card 215
card 216
card 217
card 218
card 219
card 220
card 221
card 222
card 223
card 224
card 225
card 226
card 227
card 228
card 229
card 230
card 231
card 232
card 233
card 234
card 235
card 236
card 237
card 238
card 239
card 240
card 241
card 242
card 243
card 244
card 245
card 246
card 247
card 248
card 249
card 250
card 251
card 252
card 253
card 254
card 255
card 256
card 257
card 258
card 259
card 260
card 261
card 262
card 263
card 264
card 265
card 266
card 267
card 268
card 269
card 270
card 271
card 272
card 273
card 274
card 275
card 276
card 277
card 278
card 279
card 280
card 281
card 282
card 283
card 284
card 285
KY Script Manager Routines.Figures
N Figure 6-1  Displaying a localized format string with Format2Str
Figure 6-2  Using FormatX2Str to convert floating-point numbers into
Figure 6-3  Using FormatStr2X to convert localized formatted numbers
Figure 6-4  The action of GetFormatOrder
Figure 6-5  Bidirectional selection
Figure 6-6  IntlTokenize
Figure 6-7  Pixel2Char
Figure 6-8  The action of PortionText
Figure 6-9  Using Str2Format to convert a localized string into a canonical format
Figure 6-10  StyledLineBreak
Figure 6-11  ToggleDate
Figure 6-12  The effects of transliteration
Figure 6-13  VisibleLength
Figure 6-14  Reading and writing locations
C line 27 of card 207
line 18 of card 208
line 21 of card 209
line 27 of card 225
line 27 of card 254
line 88 of card 257
line 21 of card 267
line 24 of card 268
line 18 of card 273
line 32 of card 276
line 74 of card 277
line 50 of card 278
line 7 of card 284
line 80 of card 285
KY Script Manager Routines.Tables
N Table 6-1  Char2Pixel direction constants
Table 6-2  CharByte byte types and return values
Table 6-3  Format of return value for CharType
Table 6-4  Get Environs and SetEnvirons verbs
Table 6-5  GetScript and SetScript verb constants
Table 6-6  Settings of scriptJust 
Table 6-7  Settings of scriptRedraw
Table 6-8  ScriptFlags bit numbers
Table 6-9  Characters that become tokens
Table 6-10  Nonnegative values for KeyScript
Table 6-11  PortionText yields
Table 6-12  TogglePB.togFlags bits
Table 6-13  Transliterate constant target values
Table 6-14  Transliterate constant target modifiers
Table 6-15  Transliterate constant source masks
Table 6-16  Transliterate east Asian target values
Table 6-17  Transliterate east Asian source masks
C line 18 of card 199
line 8 of card 200
line 20 of card 201
line 3 of card 213
line 3 of card 228
line 3 of card 233
line 3 of card 234
line 3 of card 240
line 51 of card 257
line 9 of card 260
line 7 of card 268
line 28 of card 277
line 25 of card 278
line 33 of card 278
line 39 of card 278
line 3 of card 280
line 12 of card 280
KY Appendix A: Testing for Compatibility.Sections
N Testing for compatibility
C card 286
KY Appendix B: International Resources.Sections
N International resources
C card 287
KY Appendix C: Word Break Tables.Sections
N Word break tables
The FindWord algorithm
Break tables
Defining character types
Continuation sequences
Coding a character triple table
C card 288
card 289
card 290
card 291
card 292
card 293
KY Appendix C: Word Break Tables.Figures
N Figure C-1  Character type table
Figure C-2  Character triple table
Figure C-3  Continuation sequence of length three
Figure C-4  Continuation sequence of length four
C line 5 of card 290
line 7 of card 290
line 3 of card 292
line 7 of card 292
KY Appendix D: Keyboards.Sections
N Keyboard structure and handling
Remapping the keyboard
Remapping at startup
Remapping the keyboard after startup
The 'KCHR' resource format
KeyTrans handling of multiple characters
'KMAP' resource format
'KCAP' resources
'KSWP' resource
International resource 'itlk'
C card 294
card 295
card 296
card 297
card 298
card 299
card 300
card 301
card 302
card 303
KY Appendix E: Enhancements to 'PACK' 6.Sections
N Enhancements to 'Pack' 6
Character set sorting
New symbol sorting
Ligature sorting
C card 304
card 305
card 306
card 307
KY Appendix F: Change History.Sections
N Change history
Script Manager and TextEdit versions
Script Manager routines
C card 308
card 309
card 310
KY Appendix G: General Reference.Sections
N General reference
Memory effects and A-5 dependencies
C card 311
card 312
KY Appendix H: Assembly-Language Info..Sections
N Assembly-language information
Stack frame for it12 routines
Trap routine selectors: Script Mgr 1.0
Trap routine selectors: Script Mgr 2.0
_ScriptUtil macros
C card 313
card 314
card 315
card 316
card 317
KY Appendix I: Working with Print Drivers.Sections
N Working with print drivers
When to call the Print Action routine
Calling the Print Action routine
C card 318
card 319
card 320
